#include <CUnit/Basic.h>
#include <gargoyle/test/scribe.h>
#include <gargoyle/scribe.h>

int init_suite_scribe(void) {
  return CUE_SUCCESS;
}

int clean_suite_scribe(void) {
  return CUE_SUCCESS;
}

void scribe_test_from_bool(void) {
  uint8_t foo = 0;

  struct gargoyle_opt opts[] = {
    { GARGOYLE_EZ_OPT("foo", foo), GARGOYLE_TYPE_BOOL }
  };

  uint8_t res = gargoyle_from_bool(opts, "", NULL, 0, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "", "", 0, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "foo", NULL, 0, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", NULL, 0, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "foo", "", 0, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "", 0, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "no-", 3, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "noon", "no-", 2, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no", "no-", 2, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no", "no-", 3, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-", "no-", 3, 0);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  // ...

  res = gargoyle_from_bool(opts, "foo", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "bar", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "noon", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "bar", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No-", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "noon", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No_", 3, GARGOYLE_FLG_ICASE);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "bar", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "NO-bar", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "no_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "bar", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "noon", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "bar", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "noon", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No-", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "no_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "noon", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No_", 3, GARGOYLE_FLG_SYMBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "NO-bar", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "no_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "NO_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No-", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "foo", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-foo", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "no_Foo", "no_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "bar", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no-bar", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_FALSE(foo);

  res = gargoyle_from_bool(opts, "noon", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "no", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "No", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);

  res = gargoyle_from_bool(opts, "Bar", "No_", 3, GARGOYLE_FLG_FLXBL);
  CU_ASSERT_EQUAL(res, GARGOYLE_ERR_SUCCESS);
  CU_ASSERT_TRUE(foo);
}

void scribe_test_from_rope(void) {
}
